(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("suncalc"));
	else if(typeof define === 'function' && define.amd)
		define("Darky", ["suncalc"], factory);
	else if(typeof exports === 'object')
		exports["Darky"] = factory(require("suncalc"));
	else
		root["Darky"] = factory(root["suncalc"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE_suncalc__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/darky.js":
/*!**********************!*\
  !*** ./src/darky.js ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _suncalc = _interopRequireDefault(__webpack_require__(/*! suncalc */ "suncalc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Darky =
/*#__PURE__*/
function () {
  function Darky() {
    var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Darky);

    this.settings = this.settings(settings); // set time

    this.time();
    if (this.settings.auto) this.auto(true); // change theme

    this.theme();
  }

  _createClass(Darky, [{
    key: "time",
    value: function time() {
      this.today = new Date();
      var midnight = new Date().setHours(24, 0, 0, 0);
      if (localStorage.time === undefined) localStorage.setItem('time', JSON.stringify(midnight));else if (localStorage.location !== undefined && this.today.getTime() > JSON.parse(localStorage.time)) {
        localStorage.removeItem('time');
        if (this.settings.cacheClear) localStorage.removeItem('location'); // onCacheClear callback

        if (typeof this.settings.onCacheClear === 'function') this.settings.onCacheClear();
      }
    }
  }, {
    key: "theme",
    value: function theme() {
      if (localStorage.dark === 'true') this.dark();else this.light();
    }
  }, {
    key: "auto",
    value: function auto(init) {
      if (init && localStorage.auto === undefined || !init) {
        localStorage.setItem('auto', true); // onReset callback

        if (typeof this.settings.onAuto === 'function') this.settings.onAuto();
        if ('geolocation' in navigator) this.myLocation();
      }
    }
  }, {
    key: "myLocation",
    value: function myLocation() {
      var _this = this;

      var location; // check if coordinates are saved in local storage

      if (localStorage.location === undefined) {
        // get coordinates from geolocation API
        navigator.geolocation.getCurrentPosition(function (pos) {
          location = {
            latitude: pos.coords.latitude,
            longitude: pos.coords.longitude
          };

          _this.checkSunPosition(location.latitude, location.longitude); // save coordinates in local storage


          if (_this.settings.cache) localStorage.setItem('location', JSON.stringify(location));
        });
      } else {
        location = JSON.parse(localStorage.location);
        this.checkSunPosition(location.latitude, location.longitude);
      }
    }
  }, {
    key: "checkSunPosition",
    value: function checkSunPosition(latitude, longitude) {
      // count sun position in your location, date and time
      var times = new _suncalc.default.getTimes(this.today, latitude, longitude); // event values

      var values = {
        sunrise: times.sunrise,
        sunset: times.sunsetStart,
        latitude: latitude,
        longitude: longitude
      }; // check if is before/after sunrise/sunset

      if (this.today.getTime() > times.sunrise.getTime() && this.today.getTime() < times.sunsetStart.getTime()) this.light();else this.dark();
      document.dispatchEvent(new CustomEvent('smartDark', {
        detail: values
      }));
    }
  }, {
    key: "reset",
    value: function reset() {
      localStorage.removeItem('time');
      localStorage.removeItem('location');
      localStorage.removeItem('dark');
      localStorage.removeItem('auto'); // onReset callback

      if (typeof this.settings.onReset === 'function') this.settings.onReset();
    }
  }, {
    key: "light",
    value: function light() {
      // onLight callback
      if (typeof this.settings.onLight === 'function') this.settings.onLight();
      this.isDark = false;
      document.body.classList.remove(this.settings.darkClass);
      if (this.settings.lightClass !== '') document.body.classList.add(this.settings.lightClass); // turn off dark mode

      localStorage.setItem('dark', false);
    }
  }, {
    key: "dark",
    value: function dark() {
      // onDark callback
      if (typeof this.settings.onDark === 'function') this.settings.onDark();
      this.isDark = true;
      if (this.settings.lightClass !== '') document.body.classList.remove(this.settings.lightClass);
      document.body.classList.add(this.settings.darkClass); // turn on dark mode

      localStorage.setItem('dark', true);
    }
  }, {
    key: "toggle",
    value: function toggle() {
      // onToggle callback
      if (typeof this.settings.onToggle === 'function') this.settings.onToggle(); // switch between light and dark theme

      if (this.isDark) this.light();else if (!this.isDark) this.dark(); // switch off smart apperance change

      localStorage.setItem('auto', false);
    }
  }, {
    key: "settings",
    value: function settings(_settings) {
      // defaults
      var defaults = {
        lightClass: '',
        // class added to body when dark mode is disabled
        darkClass: 'dark',
        // class added to body when dark mode is enabled
        cache: true,
        // cache location coordinates in local storage
        cacheClear: true,
        // clear location coordinates in local storage everyday at midnight
        auto: true,
        // enable smart switch on script init
        onAuto: null,
        // callback on smart switch
        onLight: null,
        // callback when dark mode is disabled
        onDark: null,
        // callback when dark mode is enabled
        onToggle: null,
        // callback on dark/light mode toggle
        onCacheClear: null,
        // callback when location coordinates and midnight time in local storage cleared
        onReset: null // callback on localStorage reset

      };
      var custom = {};

      for (var setting in defaults) {
        if (setting in _settings) custom[setting] = _settings[setting];else custom[setting] = defaults[setting];
      }

      return custom;
    }
  }]);

  return Darky;
}();

exports.default = Darky;
module.exports = exports["default"];

/***/ }),

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _darky = _interopRequireDefault(__webpack_require__(/*! ./darky */ "./src/darky.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = _darky.default;
exports.default = _default;
module.exports = exports["default"];

/***/ }),

/***/ "suncalc":
/*!**************************!*\
  !*** external "suncalc" ***!
  \**************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_suncalc__;

/***/ })

/******/ });
});
//# sourceMappingURL=darky.js.map